local yorsahjID = "D810" --in hex since that's how game gives it

local bloodIDs = {
	["Hspell:104894"] = "1", --Dark
	["Hspell:104900"] = "2", --Cobalt
	["Hspell:105027"] = "2", --Cobalt Maybe heroic version?
	["Hspell:104898"] = "3", --Acidic
	["Hspell:104896"] = "4", --Shadowed
	["Hspell:110748"] = "4", --Shadowed Maybe heroic version?
	["Hspell:104897"] = "5", --Crimson
	["Hspell:104901"] = "6", --Glowing
	["Hspell:108221"] = "6", --Glowing Maybe heroic version?
}
--[[ Possible future use
local summonIDs = {
	[105420] = true, --Purple, Green, Blue; Black
	[105435] = true, --Green, Red, Black; Blue
	[105436] = true, --Green, Yellow, Red; Black
	[105437] = true, --Blue, Purple, Yellow; Green
	[105439] = true, --Blue, Black, Yellow; Purple
	[105440] = true, --Purple, Red, Black; Yellow
}
]]
local function ReplaceIcons(message)
	local term
	for tag in string.gmatch(message, "%b{}") do
		term = strlower(string.gsub(tag, "[{}]", ""));
		if ( ICON_TAG_LIST[term] and ICON_LIST[ICON_TAG_LIST[term]] ) then
			message = string.gsub(message, tag, ICON_LIST[ICON_TAG_LIST[term]] .. "0|t");
		end
	end
	return message
end

local addonName, addon = ...
LibStub("AceAddon-3.0"):NewAddon(addon, addonName, "AceEvent-3.0")

function addon:OnInitialize()
	self:SetupDB()
	self:SetupOptions()
	self.summonedGlobules = {}
	self:SetEnabledState(self.db.global.enabled)
end

function addon:OnEnable()
	self:RegisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
end

function addon:CHAT_MSG_RAID_BOSS_EMOTE(event, message)
	--this may be broken 12/20/11
	--local bossGUID = UnitGUID("boss1")
	--if not bossGUID then return end --we aren't fighting anything, abort
	--if bossGUID:sub(-12, -9) ~= yorsahjID then return end --we aren't fighting yorsahj, abort
	wipe(self.summonedGlobules)
	for spellID, color in pairs(bloodIDs) do
		if message:find(spellID) then
			self.summonedGlobules[#self.summonedGlobules+1] = color
		end
	end
	local numGlobules, summonedGlobulesString, mode = #self.summonedGlobules, ""
	if ( numGlobules ~= 3 and numGlobules ~= 4 ) then return end --didnt find three/four globules, abort (should try to detect heroic mode)
	sort(self.summonedGlobules)
	for i,v in ipairs(self.summonedGlobules) do
		summonedGlobulesString = summonedGlobulesString..v
	end
	if numGlobules == 4 then
		mode = "heroic"
	else
		if IsInLFGDungeon() then
			mode = "lfr"
		else
			mode = "normal"
		end
	end
	self.killGlobule = self.db.global.priorities[mode][summonedGlobulesString]
	self:OutputWarning()
end
			
function addon:OutputWarning()
	local announceSettings = self.db.global.announces
	if announceSettings.yell then
		SendChatMessage(self.killGlobule, "YELL")
	end
	if announceSettings.raid then
		SendChatMessage(self.killGlobule, "RAID")
	end
	if announceSettings.raidWarning then
		if IsRaidLeader("player") or IsRaidOfficer("player") then
			SendChatMessage(self.killGlobule, "RAID_WARNING")
		end
	end
	if announceSettings.privateRaidWarning then
		RaidNotice_AddMessage(RaidWarningFrame, ReplaceIcons(self.killGlobule), ChatTypeInfo["RAID_WARNING"])
		PlaySoundFile("Sound\\Interface\\RaidWarning.wav")
	end
	if announceSettings.privateChatMessage then
		print(ReplaceIcons(self.killGlobule))
	end
end